//------------------------------------------------------------------------------
// 
// 
//      ,   stm32f0 (Slave)
// ,   ,      .
// 

//        
//    stm32f051x8    "
// "   .     STM32F103C8.

//     SPI    .
//          
//       .

//         ,
//      
// ,   ,  . (, ,
//      stm32f0).

//            
// https://vcc-gnd.world.taobao.com (stm32f103c8t6)   ()
// OLED  http://www.solomon-systech.com   SSD1309.
//          
//      .

//      OLED SSD1306.  , 
//   SSD1309.        
//  .         .

// This is Open source software. You can place this code on your site, but don't
// forget a link to my YouTube-channel: https://www.youtube.com/channel/UChButpZaL5kUUl_zTyIDFkQ
//     .   
//    ,        YouTube- 
// "  " https://www.youtube.com/channel/UChButpZaL5kUUl_zTyIDFkQ
// :   / Nadyrshin Ruslan

//   SPI      http://chipspace.ru/stm32-spi/
//    http://radiokot.ru/forum/viewtopic.php?t=119263
//       http://radiokot.ru/forum/viewtopic.php?f=59&t=109456


//----------------------------  ---------------------------
#include "stm32f10x.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_gpio.h"
#include "main.h"
#include <delay.h>
#include <disp1color.h>
#include <font.h>

uint8_t font = FONTID_6X8M;
#define delay   2000
//------------------------------------------------------------------------------


#define Sl_D_Load_LOW   GPIOB->BRR |= GPIO_ODR_ODR5;    //    
//    SPI2->DR = data  STM32F030
#define Sl_D_Load_HIGH  GPIOB->BSRR |= GPIO_BSRR_BS5;   //    PB3


#define CS_LOW         GPIOB->BRR |= GPIO_ODR_ODR12;    GPIOC->BRR |= GPIO_ODR_ODR13;
// PB12   "CS" (NSS), CS_LOW  SCK   .
#define CS_HIGH        GPIOB->BSRR |= GPIO_BSRR_BS12;   GPIOC->BSRR |= GPIO_BSRR_BS13;
// PC13  .  .


//      
#define   T3_PSC        7200                    // 10KHz or 0.0001s
#define   T3_ARR        1000                    // 1000 period = 0.1 sec
static volatile unsigned Tim_Flag = 0;  //    (   )


//   3    
#define L_SPI2_B   9    //   SPI.  Tr, Rs   .
int Cn_SPI2_B = 0;      //  .   SPI 16- 
int SPI2_Buff [L_SPI2_B] = {0, 0, 0, 0, 0, 0, 0, 0, 0};
//        
//     2 .
//         .
int *p_SPI2_Buff;
int SPI2_KS = 0;        //   SPI (,    
//   16   .         .


//          
struct fibo {
int N_1;        //    
int N_2;        //    
int N_3;        //    
int It_N;       //  
            } N_fibo;

struct fibo N_fibo = {0, 0, 0, 0};
struct fibo N_fibo, *n_f = &N_fibo;


//----------------------------------- Tim3 -------------------------------------

void TIM3_IRQHandler(void)
{
   if(TIM3->SR & TIM_SR_UIF)   {
    TIM3->SR &= ~TIM_SR_UIF;    //   
    Tim_Flag = 1;               //   
                               }
}
//---------------------------------- SPI2 --------------------------------------

int Spi_Exchange_Data (int data)
{
Sl_D_Load_HIGH                          //     

//     STM32F0,       
while(!(GPIOB->IDR & GPIO_IDR_IDR4));   //  SPI_DR.   .
Sl_D_Load_LOW                           //     

//     
while(!(SPI2->SR & SPI_SR_TXE));        // (    )
  SPI2->DR = data;                      //     
  
//  SCK.  CS   ,     SPI
CS_LOW  //      

while(!(SPI2->SR & SPI_SR_RXNE));       //    ()
  data = SPI2->DR;                      //   

CS_HIGH                                 //  SCK
 
 return data; 
}

//------------------------ Struct --> Bufer-----------------------------
// Struct --> Bufer --> Struct
//        .
//        Slave.
//  -   Master.
//    .
//       Slave  .    
void Tr_Data () {         // Tr, Rs   . 
//SPI2_Buff [0] = n_f->N_1 >> 16;                 //   
//SPI2_Buff [1] = n_f->N_1 & (0x0000FFFF);        //    
//SPI2_Buff [2] = n_f->N_2 >> 16;                 //   
//SPI2_Buff [3] = n_f->N_2 & (0x0000FFFF);        //    
//SPI2_Buff [4] = n_f->N_3 >> 16;                 //   
//SPI2_Buff [5] = n_f->N_3 & (0x0000FFFF);        //    
//SPI2_Buff [6] = n_f->It_N >> 16;                //   
//SPI2_Buff [7] = n_f->It_N & (0x0000FFFF);       //    
              }

//--------------------------- Bufer --> Struct-----------------------------
void Rs_Data () {                 // Tr, Rs   .  
n_f->N_1    =  SPI2_Buff [0];
n_f->N_1    =  n_f->N_1 << 16;          //   
n_f->N_1   |=  SPI2_Buff [1];           //    
n_f->N_2    =  SPI2_Buff [2];
n_f->N_2    =  n_f->N_2 << 16;          //   
n_f->N_2   |=  SPI2_Buff [3];           //    
n_f->N_3    =  SPI2_Buff [4];
n_f->N_3    =  n_f->N_3 << 16;          //   
n_f->N_3   |=  SPI2_Buff [5];           //    
n_f->It_N   =  SPI2_Buff [6];
n_f->It_N   =  n_f->It_N << 16;         //   
n_f->It_N  |=  SPI2_Buff [7];           //     
              }
//-------------------------  -----------------------------
int SPI_KS () {         //         +1,
uint32_t ks = 1;        //    0    . 
  for (int i = 0; i < L_SPI2_B - 2; i++)	//       
ks = ks + SPI2_Buff[i];
ks &= ~(0xFFFF0000);
SPI2_Buff[L_SPI2_B - 1] = ks;
return SPI2_Buff[L_SPI2_B - 1];
}


void main()
{
  
//-----------------------------   ---------------------------
  SystemInit();
  
  disp1color_Init();
  disp1color_SetBrightness(255);
//------------------------------------------------------------------------------
  

//--------------------------------Timer3----------------------------------------
   


   RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;  //    
   
   TIM3->PSC = T3_PSC - 1;              // 10KHz or 0.0001s
   TIM3->ARR = T3_ARR;                  // 10000 period = 1 sec
   TIM3->DIER |= TIM_DIER_UIE;          //    

   
//-------------------------------SPI----------------------------------------------------------------------------
//SPIx_SCK        Master  Alternate function push-pull

//SPI pinout                    Configuration                   GPIO configuration
//SPIx_SCK                      Master                          Alternate function push-pull
//                              Slave                           Input floating

//SPIx_MOSI     Full duplex     master                          Alternate function push-pull
//              Full duplex     slave                           Input floating / Input pull-up

//SPIx_MISO     Full duplex     master                          Input floating / Input pull-up
//              Full duplex     slave (point to point)          Alternate function push-pull
//              Full duplex     slave (multi-slave)             Alternate function open drain

//SPIx_NSS      Hardware master /slave                          Input floating/ Input pull-up / Input pull-down
//              Hardware master/ NSS output enabled             Alternate function push-pull
//              Software Not used.                              Can be used as a GPIO
//--------------------------------------------------------------------------------------------------------------
  RCC->APB2ENR |= RCC_APB2ENR_IOPBEN;          //    B 
  RCC->APB2ENR |= RCC_APB2ENR_IOPCEN;          //    C 
  RCC->APB2ENR  |= RCC_APB2ENR_AFIOEN;    //   .       

// ! !!    stm32f103      0-7   GPIOB->CRL,   8-15  GPIOB->CRH
// CRL & CRH
// MODE
//      00      
//      01       10 
//      10       2  
//      11       50  
// CNF  MODE 00
//      00       
//      01        ()
//      10            
//      11      
// CNF  MODE 01, 10 11
//      00       GPIO Push-pull
//      01       GPIO Open drain
//      10         Push-pull
//      11         Open drain
//#define  GPIO_CRH_MODE8                      ((uint32_t)0x00000003)        /*!< MODE8[1:0] bits (Port x mode bits, pin 8) */
//#define  GPIO_CRH_MODE8_0                    ((uint32_t)0x00000001)        /*!< Bit 0 */
//#define  GPIO_CRH_MODE8_1                    ((uint32_t)0x00000002)        /*!< Bit 1 */

//#define  GPIO_CRH_CNF8                       ((uint32_t)0x0000000C)        /*!< CNF8[1:0] bits (Port x configuration bits, pin 8) */
//#define  GPIO_CRH_CNF8_0                     ((uint32_t)0x00000004)        /*!< Bit 0 */
//#define  GPIO_CRH_CNF8_1                     ((uint32_t)0x00000008)        /*!< Bit 1 */

//----------------------------------------------------------------------------------------------------------------------------------------
//Configuration mode                            CNF1    CNF0    MODE1   MODE0   PxODRregister

//General purpose
//output                Push-pull               0       0                       0 or 1
//                      Open-drain              0       1                       0 or 1

//Alternate Function    Push-pull               1       0                       dont care
//output                Open-drain              1       1                       dont care

//Input                 Analog                  0       0       0       0       dont care
//                      Input floating          0       1       0       0       dont care
//                      Input pull-down         1       0       0       0       0
//                      Input pull-up           1       0       0       0       1
//-----------------------------------------------------------------------------------------------------------------------------------------
  

// Pc13  , 50 MHz.  ,   CS_LOW
	GPIOC->CRH |= GPIO_CRH_MODE13;
	GPIOC->CRH &= ~GPIO_CRH_CNF13;
        GPIOC->ODR &= ~GPIO_ODR_ODR13;
        

  
  
// PB12 - SPI2_NSS
// PB13 - SPI2_SCK
// PB14 - SPI2_MISO (Master In)
// PB15 - SPI2_MOSI (Master Out)
        

// PB4 - SL_Redy ( 1 -  STM32F030  ,   SPI_DR  TXE = 1
	GPIOB->CRL &= ~GPIO_CRL_MODE4;  // 
        GPIOB->CRL &= ~GPIO_CRL_CNF4;   //   
	GPIOB->CRL |= GPIO_CRL_CNF4_1;  //   
        GPIOB->ODR &= ~GPIO_ODR_ODR4;   //    (   )
        
// PB5  , 50 MHz   ,     SLVE
        GPIOB->CRL |= GPIO_CRL_MODE5;   // PB12 NSS  , 50 MHz
	GPIOB->CRL &= ~GPIO_CRL_CNF5;   //    (   00 - Push-pull 
	GPIOB->ODR &= ~GPIO_ODR_ODR5;   //    !       !        

// PB14 - SPI2_MISO (Master In) Push-pull
	GPIOB->CRH &= ~GPIO_CRH_MODE14;  // 
        GPIOB->CRH &= ~GPIO_CRH_CNF14;   //   
	GPIOB->CRH |= GPIO_CRH_CNF14_0;  //  
//      GPIOB->ODR &= ~GPIO_ODR_ODR14;   //   
        
// PB12, PB13, PB15  -,  , 50 MHz
	GPIOB->CRH |= GPIO_CRH_MODE12;          // PB12 NSS  , 50 MHz
	GPIOB->CRH &= ~GPIO_CRH_CNF12;          //   
        GPIOB->CRH |= GPIO_CRH_CNF12_1;         //    Push-pull 
	GPIOB->CRH |= GPIO_CRH_MODE13;          // PB13 SCK  , 50 MHz
	GPIOB->CRH &= ~GPIO_CRH_CNF13;          //   
        GPIOB->CRH |= GPIO_CRH_CNF13_1;         //    Push-pull 
	GPIOB->CRH |= GPIO_CRH_MODE15;          // PB15 MOSI  , 50 MHz
	GPIOB->CRH &= ~GPIO_CRH_CNF15;          //   
        GPIOB->CRH |= GPIO_CRH_CNF15_1;         //    Push-pull 	
 
//  SPI2
	RCC->APB1ENR |= RCC_APB1ENR_SPI2EN; 
CS_HIGH
Sl_D_Load_LOW
	
        SPI2->CR1 |= SPI_CR1_BR;                //111: fPCLK / 256
        SPI2->CR1 &= ~SPI_CR1_CPOL;             //Polarity cls signal CPOL = 0; SCK 0 ()  
        SPI2->CR1 &= ~SPI_CR1_CPHA;             //Phase cls signal    CPHA = 0;         
        SPI2->CR1 |= SPI_CR1_DFF;               //16 bit data
        SPI2->CR1 &= ~SPI_CR1_LSBFIRST;         //MSB will be first
        SPI2->CR1 |= SPI_CR1_SSI;               //Software slave management & Internal slave select
        SPI2->CR1 |= SPI_CR1_SSM;               //   NSS (SSM = 0, SSOE = 1)
	SPI2->CR2 |= SPI_CR2_SSOE;              // NSS -     slave select (0x0004)
        SPI2->CR1 |= SPI_CR1_MSTR;              //Mode Master
        SPI2->CR1 |= SPI_CR1_SPE;               //Enable SPI2

//---------------------------------------------------------------------------------------------------

        
        
        
        
        
Tr_Data(); 
SPI2_Buff[L_SPI2_B - 1] = SPI_KS();


      TIM3->EGR |= TIM_EGR_UG;             //  
      TIM3->CR1 |= TIM_CR1_CEN;            // 
NVIC->ISER[0] = (1 << ((TIM3_IRQn) & 0x1F));     //  TIM3_IRQn  & 0x1F


//______________________________________________________________________________
  while (1)
  { 
    
if (Tim_Flag == 1) {    //    TIM3
      
//     
for (int i = 0; i < L_SPI2_B; i++) SPI2_Buff[i] = Spi_Exchange_Data(SPI2_Buff[i]);


SPI2_KS = SPI2_Buff[L_SPI2_B - 1];      //    
SPI2_Buff[L_SPI2_B - 1] = SPI_KS();     //    

if (SPI2_KS == SPI2_Buff[L_SPI2_B - 1]) //     
Rs_Data();  
//     else,      ,
//  -    .
//           ,
//       ,   .
//  ,      .   
//    ,      
// ,   .    

//------------------------------------------------------------------------------

disp1color_printf(10, 4, font, "");
disp1color_printf(93, 4, font,"%6d", n_f->It_N);
disp1color_printf(10, 16, font, "");

disp1color_printf(75, 32, font,"%9d", n_f->N_1);
disp1color_printf(75, 44, font,"%9d", n_f->N_2);
disp1color_printf(75, 56, font,"%9d", n_f->N_3);

switch( n_f->It_N )   
{  
    case 1:  disp1color_printf(0, 56, font, "          ");  break;
    case 45: disp1color_printf(0, 56, font, "! STM32");  break;
}


disp1color_UpdateFromBuff();    //   

Tr_Data();

SPI2_Buff[L_SPI2_B - 1] = SPI_KS();            //   .
  
   
Tim_Flag = 0;   
    }




/*  
  
  //    
  disp1color_DrawRectangle(5, 5, 122, 58); 
  //  (     ) 
  disp1color_printf(10, 8, FONTID_10X16F, "\n\r \n\r%d", 2016);
  disp1color_UpdateFromBuff();
  delay_ms(4000);
  
  uint8_t font = FONTID_6X8M;
  
  while (1)
  {
    //   
    disp1color_FillScreenbuff(0);
    disp1color_printf(0, 0, font, "0123456789 \r\n@#$%^&(){}[]_\r\n!|%;:.,?+-=");
    disp1color_UpdateFromBuff();
    delay_ms(delay);
    //  -  
    disp1color_FillScreenbuff(0);
    disp1color_printf(0, 0, font, "ABCDEFGHIJKLM\r\nNOPQRSTUVWX\r\nYZ");
    disp1color_UpdateFromBuff();
    delay_ms(delay);
    //  -  
    disp1color_FillScreenbuff(0);
    disp1color_printf(0, 0, font, "abcdefghijklmnop\r\nqrstuvwxyz");
    disp1color_UpdateFromBuff();
    delay_ms(delay);
    //  -  
    disp1color_FillScreenbuff(0);
    disp1color_printf(0, 0, font, "Ũ\r\n\r\n\r\n");
    disp1color_UpdateFromBuff();
    delay_ms(delay);
    //  -  
    disp1color_FillScreenbuff(0);
    disp1color_printf(0, 0, font, "\r\n\r\n");
    disp1color_UpdateFromBuff();
    delay_ms(delay);
    
    //  
    if (font == FONTID_10X16F)
      font = FONTID_6X8M;
    else
      font = FONTID_10X16F;
    
*/    
    
  }
}
